import React from 'react';
import { AxisScale } from '@visx/xychart';
import { AnimationTrajectory } from '@visx/react-spring/lib/types';
import { TickLabelProps } from '@visx/axis/lib/types';
import { ScaleInput } from '@visx/scale';
import { CurveFactory, CurveFactoryLineOnly } from 'd3-shape';
import { RenderTooltipParams } from '@visx/xychart/lib/components/Tooltip';
export interface IDatum extends Record<string | number, string | number> {
    x: string | number;
    y: string | number;
}
export interface IAccesorProps {
    xAccessor: (d: IDatum | any) => string | number;
    yAccessor: (d: IDatum | any) => string | number;
}
export declare type AnimatedTrajectroyType = {
    animationTrajectory?: AnimationTrajectory;
};
export interface ITickComponentProps {
    x: number;
    y: number;
    dx?: number | string;
    dy?: number | string;
    formattedValue: string | undefined;
}
export interface IAxisProps {
    axisLineClassName?: string;
    hideZero?: boolean;
    label?: string;
    labelClassName?: string;
    labelOffset?: number;
    show?: boolean;
    tickClassName?: string;
    tickLength?: number;
    tickComponent?: (props: ITickComponentProps) => React.ReactNode;
    tickFormat?: (d: string) => string;
    tickLabelProps?: TickLabelProps<ScaleInput<AxisScale>>;
}
export interface ILineProps extends Record<string, string> {
    className: string;
    dataKey: string;
}
export interface IXYLineChartProps {
    accessors: (props: any) => IAccesorProps;
    curve?: CurveFactory | CurveFactoryLineOnly;
    data: IDatum[];
    lineKeys: ILineProps[];
    gridLineStroke?: string;
    height: number;
    leftAxis?: IAxisProps;
    margins?: {
        bottom: number;
        left: number;
        right: number;
        top: number;
    };
    renderTooltip: (props: RenderTooltipParams<IDatum>) => React.ReactNode;
    rightAxis?: IAxisProps;
    rowTicks?: number;
    width: number;
}
export declare const LEFT_RIGHT_AXIS_COMMON_PROPS: {
    animationTrajectory: string;
    axisLineClassName: string;
    hideZero: boolean;
    labelClassName: string;
    labelOffset: number;
    tickClassName: string;
    tickLength: number;
    tickStroke: string;
};
export declare function XYLineChart({ accessors, curve, data, gridLineStroke, height, leftAxis, lineKeys, margins, rightAxis, renderTooltip, rowTicks, width, }: IXYLineChartProps): JSX.Element;
//# sourceMappingURL=XYLineChart.d.ts.map