export declare type DefaultItem = Record<any, any>;
export declare type ItemIdentifierKey<Item> = keyof Item;
export declare type ItemWithSelectedState<T> = T & {
    isSelected: boolean;
    [key: string]: any;
};
export declare type Arguments<Item> = {
    initialItems: Array<Item>;
    itemIdentifierKey: ItemIdentifierKey<Item>;
    initialSelectedItems?: Array<Item>;
    toggleAll?: boolean;
};
export declare type State<Item> = {
    items: Array<ItemWithSelectedState<Item>>;
    itemIdentifierKey: ItemIdentifierKey<Item>;
    toggleAll: boolean;
};
export declare const ActionType: {
    readonly INITIALIZE_ITEMS: "INITIALIZE_ITEMS";
    readonly TOGGLE_ALL_ITEMS: "TOGGLE_ALL_ITEMS";
    readonly TOGGLE_SINGLE_ITEM: "TOGGLE_SINGLE_ITEM";
};
declare type ActionPayloads<Item extends DefaultItem> = {
    [ActionType.TOGGLE_SINGLE_ITEM]: {
        itemIdentifierValue?: Item[ItemIdentifierKey<Item>];
    };
    [ActionType.INITIALIZE_ITEMS]: {
        initialSelectedItems: Array<Item>;
        initialItems: Array<Item>;
    };
    [ActionType.TOGGLE_ALL_ITEMS]: {
        toggleAll: boolean | undefined;
    };
};
declare type ActionMap<M extends Record<string, any>> = {
    [Key in keyof M]: M[Key] extends undefined ? {
        type: Key;
    } : {
        type: Key;
        payload: M[Key];
    };
};
export declare type Action<Item extends DefaultItem> = ActionMap<ActionPayloads<Item>>[keyof ActionMap<ActionPayloads<Item>>];
export {};
//# sourceMappingURL=types.d.ts.map